**About**

This project implements a node HTTP server which can accept [webhook requests from SendGrid](http://sendgrid.com/docs/API_Reference/Webhooks/index.html).

You can configure SendGrid to make webhook calls when email is processed, dropped, deferred, delivered, bounced, clicked, opened, unsubscribed from or marked as spam.

This server transforms the event information from SendGrid into HipChat-valid HTML and posts it into a HipChat room for monitoring.

**Configuration**

You'll need a HipChat API Auth Token of type Admin to be able to post messages to HipChat. You'll also need the room number of the HipChat room you want to post to. The room number can be had from the URL of the chat history web page for the room in question.

In your SendGrid configuration, enable the Event Notification App. It is disabled by default. Within its settings, you can choose which kinds of events you're interested in. We typically monitor: dropped, bounced, unsubscribe, and spam.  Monitoring deferred events seemed to cause a lot of noise.

**Batch event notifications:** Leave this unchecked, as the code can't handle batches yet.

**Post Event URL:** https://yourserver.com/postSendGridMessage?apikey=a-valid-hipchat-api-key&room=a-valid-HipChat-room-number&user=your-sendgrid-subuser-id&environment=a-string-of-your-choosing

**To Dos**

 - Unit tests
 - Make dependence on SendGrid sub-user accounts optional. We use them, you might not.
 - Add support for "Batch event notifications" in SendGrid.
 - Add support for posting to multiple HipChat rooms.
